/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.CustomArticleFieldAdd;
import io.swagger.client.model.FundingCreate;
import io.swagger.client.model.RelatedMaterial;
import io.swagger.client.model.TimelineUpdate;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ArticleProjectCreate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-29T12:13:04.813Z")
public class ArticleProjectCreate {
  @SerializedName("title")
  private String title = null;

  @SerializedName("description")
  private String description = "";

  @SerializedName("tags")
  private List<String> tags = null;

  @SerializedName("keywords")
  private List<String> keywords = null;

  @SerializedName("references")
  private List<String> references = null;

  @SerializedName("related_materials")
  private List<RelatedMaterial> relatedMaterials = null;

  @SerializedName("categories")
  private List<Long> categories = null;

  @SerializedName("categories_by_source_id")
  private List<String> categoriesBySourceId = null;

  @SerializedName("authors")
  private List<Object> authors = null;

  @SerializedName("custom_fields")
  private Object customFields = null;

  @SerializedName("custom_fields_list")
  private List<CustomArticleFieldAdd> customFieldsList = null;

  @SerializedName("defined_type")
  private String definedType = null;

  @SerializedName("funding")
  private String funding = "";

  @SerializedName("funding_list")
  private List<FundingCreate> fundingList = null;

  @SerializedName("license")
  private Long license = 0l;

  @SerializedName("doi")
  private String doi = "";

  @SerializedName("handle")
  private String handle = "";

  @SerializedName("resource_doi")
  private String resourceDoi = "";

  @SerializedName("resource_title")
  private String resourceTitle = "";

  @SerializedName("timeline")
  private TimelineUpdate timeline = null;

  public ArticleProjectCreate title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Title of article
   * @return title
  **/
  @ApiModelProperty(example = "Test article title", required = true, value = "Title of article")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ArticleProjectCreate description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The article description. In a publisher case, usually this is the remote article description
   * @return description
  **/
  @ApiModelProperty(example = "Test description of article", value = "The article description. In a publisher case, usually this is the remote article description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ArticleProjectCreate tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public ArticleProjectCreate addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * List of tags to be associated with the article. Keywords can be used instead
   * @return tags
  **/
  @ApiModelProperty(example = "[\"tag1\",\"tag2\"]", value = "List of tags to be associated with the article. Keywords can be used instead")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public ArticleProjectCreate keywords(List<String> keywords) {
    this.keywords = keywords;
    return this;
  }

  public ArticleProjectCreate addKeywordsItem(String keywordsItem) {
    if (this.keywords == null) {
      this.keywords = new ArrayList<String>();
    }
    this.keywords.add(keywordsItem);
    return this;
  }

   /**
   * List of tags to be associated with the article. Tags can be used instead
   * @return keywords
  **/
  @ApiModelProperty(example = "[\"tag1\",\"tag2\"]", value = "List of tags to be associated with the article. Tags can be used instead")
  public List<String> getKeywords() {
    return keywords;
  }

  public void setKeywords(List<String> keywords) {
    this.keywords = keywords;
  }

  public ArticleProjectCreate references(List<String> references) {
    this.references = references;
    return this;
  }

  public ArticleProjectCreate addReferencesItem(String referencesItem) {
    if (this.references == null) {
      this.references = new ArrayList<String>();
    }
    this.references.add(referencesItem);
    return this;
  }

   /**
   * List of links to be associated with the article (e.g [\&quot;http://link1\&quot;, \&quot;http://link2\&quot;, \&quot;http://link3\&quot;])
   * @return references
  **/
  @ApiModelProperty(example = "[\"http://figshare.com\",\"http://api.figshare.com\"]", value = "List of links to be associated with the article (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])")
  public List<String> getReferences() {
    return references;
  }

  public void setReferences(List<String> references) {
    this.references = references;
  }

  public ArticleProjectCreate relatedMaterials(List<RelatedMaterial> relatedMaterials) {
    this.relatedMaterials = relatedMaterials;
    return this;
  }

  public ArticleProjectCreate addRelatedMaterialsItem(RelatedMaterial relatedMaterialsItem) {
    if (this.relatedMaterials == null) {
      this.relatedMaterials = new ArrayList<RelatedMaterial>();
    }
    this.relatedMaterials.add(relatedMaterialsItem);
    return this;
  }

   /**
   * List of related materials; supersedes references and resource DOI/title.
   * @return relatedMaterials
  **/
  @ApiModelProperty(example = "[{\"id\":10432,\"identifier\":\"10.6084/m9.figshare.1407024\",\"identifier_type\":\"DOI\",\"relation\":\"IsSupplementTo\",\"title\":\"Figshare for institutions brochure\",\"is_linkout\":false}]", value = "List of related materials; supersedes references and resource DOI/title.")
  public List<RelatedMaterial> getRelatedMaterials() {
    return relatedMaterials;
  }

  public void setRelatedMaterials(List<RelatedMaterial> relatedMaterials) {
    this.relatedMaterials = relatedMaterials;
  }

  public ArticleProjectCreate categories(List<Long> categories) {
    this.categories = categories;
    return this;
  }

  public ArticleProjectCreate addCategoriesItem(Long categoriesItem) {
    if (this.categories == null) {
      this.categories = new ArrayList<Long>();
    }
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * List of category ids to be associated with the article(e.g [1, 23, 33, 66])
   * @return categories
  **/
  @ApiModelProperty(example = "[1,10,11]", value = "List of category ids to be associated with the article(e.g [1, 23, 33, 66])")
  public List<Long> getCategories() {
    return categories;
  }

  public void setCategories(List<Long> categories) {
    this.categories = categories;
  }

  public ArticleProjectCreate categoriesBySourceId(List<String> categoriesBySourceId) {
    this.categoriesBySourceId = categoriesBySourceId;
    return this;
  }

  public ArticleProjectCreate addCategoriesBySourceIdItem(String categoriesBySourceIdItem) {
    if (this.categoriesBySourceId == null) {
      this.categoriesBySourceId = new ArrayList<String>();
    }
    this.categoriesBySourceId.add(categoriesBySourceIdItem);
    return this;
  }

   /**
   * List of category source ids to be associated with the article, supersedes the categories property
   * @return categoriesBySourceId
  **/
  @ApiModelProperty(example = "[\"300204\",\"400207\"]", value = "List of category source ids to be associated with the article, supersedes the categories property")
  public List<String> getCategoriesBySourceId() {
    return categoriesBySourceId;
  }

  public void setCategoriesBySourceId(List<String> categoriesBySourceId) {
    this.categoriesBySourceId = categoriesBySourceId;
  }

  public ArticleProjectCreate authors(List<Object> authors) {
    this.authors = authors;
    return this;
  }

  public ArticleProjectCreate addAuthorsItem(Object authorsItem) {
    if (this.authors == null) {
      this.authors = new ArrayList<Object>();
    }
    this.authors.add(authorsItem);
    return this;
  }

   /**
   * List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.
   * @return authors
  **/
  @ApiModelProperty(example = "[{\"name\":\"John Doe\"},{\"id\":1000008}]", value = "List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.")
  public List<Object> getAuthors() {
    return authors;
  }

  public void setAuthors(List<Object> authors) {
    this.authors = authors;
  }

  public ArticleProjectCreate customFields(Object customFields) {
    this.customFields = customFields;
    return this;
  }

   /**
   * List of key, values pairs to be associated with the article
   * @return customFields
  **/
  @ApiModelProperty(example = "{\"defined_key\":\"value for it\"}", value = "List of key, values pairs to be associated with the article")
  public Object getCustomFields() {
    return customFields;
  }

  public void setCustomFields(Object customFields) {
    this.customFields = customFields;
  }

  public ArticleProjectCreate customFieldsList(List<CustomArticleFieldAdd> customFieldsList) {
    this.customFieldsList = customFieldsList;
    return this;
  }

  public ArticleProjectCreate addCustomFieldsListItem(CustomArticleFieldAdd customFieldsListItem) {
    if (this.customFieldsList == null) {
      this.customFieldsList = new ArrayList<CustomArticleFieldAdd>();
    }
    this.customFieldsList.add(customFieldsListItem);
    return this;
  }

   /**
   * List of custom fields values, supersedes custom_fields parameter
   * @return customFieldsList
  **/
  @ApiModelProperty(value = "List of custom fields values, supersedes custom_fields parameter")
  public List<CustomArticleFieldAdd> getCustomFieldsList() {
    return customFieldsList;
  }

  public void setCustomFieldsList(List<CustomArticleFieldAdd> customFieldsList) {
    this.customFieldsList = customFieldsList;
  }

  public ArticleProjectCreate definedType(String definedType) {
    this.definedType = definedType;
    return this;
  }

   /**
   * &lt;b&gt;One of:&lt;/b&gt; &lt;code&gt;figure&lt;/code&gt; &lt;code&gt;online resource&lt;/code&gt; &lt;code&gt;preprint&lt;/code&gt; &lt;code&gt;book&lt;/code&gt; &lt;code&gt;conference contribution&lt;/code&gt; &lt;code&gt;media&lt;/code&gt; &lt;code&gt;dataset&lt;/code&gt; &lt;code&gt;poster&lt;/code&gt; &lt;code&gt;journal contribution&lt;/code&gt; &lt;code&gt;presentation&lt;/code&gt; &lt;code&gt;thesis&lt;/code&gt; &lt;code&gt;software&lt;/code&gt;
   * @return definedType
  **/
  @ApiModelProperty(example = "media", value = "<b>One of:</b> <code>figure</code> <code>online resource</code> <code>preprint</code> <code>book</code> <code>conference contribution</code> <code>media</code> <code>dataset</code> <code>poster</code> <code>journal contribution</code> <code>presentation</code> <code>thesis</code> <code>software</code>")
  public String getDefinedType() {
    return definedType;
  }

  public void setDefinedType(String definedType) {
    this.definedType = definedType;
  }

  public ArticleProjectCreate funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Grant number or funding authority
   * @return funding
  **/
  @ApiModelProperty(value = "Grant number or funding authority")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public ArticleProjectCreate fundingList(List<FundingCreate> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public ArticleProjectCreate addFundingListItem(FundingCreate fundingListItem) {
    if (this.fundingList == null) {
      this.fundingList = new ArrayList<FundingCreate>();
    }
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Funding creation / update items
   * @return fundingList
  **/
  @ApiModelProperty(value = "Funding creation / update items")
  public List<FundingCreate> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingCreate> fundingList) {
    this.fundingList = fundingList;
  }

  public ArticleProjectCreate license(Long license) {
    this.license = license;
    return this;
  }

   /**
   * License id for this article.
   * @return license
  **/
  @ApiModelProperty(example = "1", value = "License id for this article.")
  public Long getLicense() {
    return license;
  }

  public void setLicense(Long license) {
    this.license = license;
  }

  public ArticleProjectCreate doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
   * @return doi
  **/
  @ApiModelProperty(value = "Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public ArticleProjectCreate handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
   * @return handle
  **/
  @ApiModelProperty(value = "Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public ArticleProjectCreate resourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
    return this;
  }

   /**
   * Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.
   * @return resourceDoi
  **/
  @ApiModelProperty(value = "Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.")
  public String getResourceDoi() {
    return resourceDoi;
  }

  public void setResourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
  }

  public ArticleProjectCreate resourceTitle(String resourceTitle) {
    this.resourceTitle = resourceTitle;
    return this;
  }

   /**
   * Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.
   * @return resourceTitle
  **/
  @ApiModelProperty(value = "Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.")
  public String getResourceTitle() {
    return resourceTitle;
  }

  public void setResourceTitle(String resourceTitle) {
    this.resourceTitle = resourceTitle;
  }

  public ArticleProjectCreate timeline(TimelineUpdate timeline) {
    this.timeline = timeline;
    return this;
  }

   /**
   * Various timeline dates
   * @return timeline
  **/
  @ApiModelProperty(value = "Various timeline dates")
  public TimelineUpdate getTimeline() {
    return timeline;
  }

  public void setTimeline(TimelineUpdate timeline) {
    this.timeline = timeline;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ArticleProjectCreate articleProjectCreate = (ArticleProjectCreate) o;
    return Objects.equals(this.title, articleProjectCreate.title) &&
        Objects.equals(this.description, articleProjectCreate.description) &&
        Objects.equals(this.tags, articleProjectCreate.tags) &&
        Objects.equals(this.keywords, articleProjectCreate.keywords) &&
        Objects.equals(this.references, articleProjectCreate.references) &&
        Objects.equals(this.relatedMaterials, articleProjectCreate.relatedMaterials) &&
        Objects.equals(this.categories, articleProjectCreate.categories) &&
        Objects.equals(this.categoriesBySourceId, articleProjectCreate.categoriesBySourceId) &&
        Objects.equals(this.authors, articleProjectCreate.authors) &&
        Objects.equals(this.customFields, articleProjectCreate.customFields) &&
        Objects.equals(this.customFieldsList, articleProjectCreate.customFieldsList) &&
        Objects.equals(this.definedType, articleProjectCreate.definedType) &&
        Objects.equals(this.funding, articleProjectCreate.funding) &&
        Objects.equals(this.fundingList, articleProjectCreate.fundingList) &&
        Objects.equals(this.license, articleProjectCreate.license) &&
        Objects.equals(this.doi, articleProjectCreate.doi) &&
        Objects.equals(this.handle, articleProjectCreate.handle) &&
        Objects.equals(this.resourceDoi, articleProjectCreate.resourceDoi) &&
        Objects.equals(this.resourceTitle, articleProjectCreate.resourceTitle) &&
        Objects.equals(this.timeline, articleProjectCreate.timeline);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, description, tags, keywords, references, relatedMaterials, categories, categoriesBySourceId, authors, customFields, customFieldsList, definedType, funding, fundingList, license, doi, handle, resourceDoi, resourceTitle, timeline);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ArticleProjectCreate {\n");
    
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    keywords: ").append(toIndentedString(keywords)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    relatedMaterials: ").append(toIndentedString(relatedMaterials)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    categoriesBySourceId: ").append(toIndentedString(categoriesBySourceId)).append("\n");
    sb.append("    authors: ").append(toIndentedString(authors)).append("\n");
    sb.append("    customFields: ").append(toIndentedString(customFields)).append("\n");
    sb.append("    customFieldsList: ").append(toIndentedString(customFieldsList)).append("\n");
    sb.append("    definedType: ").append(toIndentedString(definedType)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    license: ").append(toIndentedString(license)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    resourceDoi: ").append(toIndentedString(resourceDoi)).append("\n");
    sb.append("    resourceTitle: ").append(toIndentedString(resourceTitle)).append("\n");
    sb.append("    timeline: ").append(toIndentedString(timeline)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

