/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Author;
import io.swagger.client.model.Category;
import io.swagger.client.model.Collection;
import io.swagger.client.model.CustomArticleField;
import io.swagger.client.model.FundingInformation;
import io.swagger.client.model.Timeline;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * CollectionCompletePrivate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-29T12:13:04.813Z")
public class CollectionCompletePrivate extends Collection {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("doi")
  private String doi = null;

  @SerializedName("handle")
  private String handle = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("timeline")
  private Timeline timeline = null;

  @SerializedName("account_id")
  private Long accountId = null;

  @SerializedName("funding")
  private List<FundingInformation> funding = new ArrayList<FundingInformation>();

  @SerializedName("resource_id")
  private String resourceId = null;

  @SerializedName("resource_doi")
  private String resourceDoi = null;

  @SerializedName("resource_title")
  private String resourceTitle = null;

  @SerializedName("resource_link")
  private String resourceLink = null;

  @SerializedName("resource_version")
  private Long resourceVersion = null;

  @SerializedName("version")
  private Long version = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("categories")
  private List<Category> categories = new ArrayList<Category>();

  @SerializedName("references")
  private List<String> references = new ArrayList<String>();

  @SerializedName("tags")
  private List<String> tags = new ArrayList<String>();

  @SerializedName("authors")
  private List<Author> authors = new ArrayList<Author>();

  @SerializedName("institution_id")
  private Long institutionId = null;

  @SerializedName("group_id")
  private Long groupId = null;

  @SerializedName("articles_count")
  private Long articlesCount = null;

  @SerializedName("public")
  private Boolean _public = null;

  @SerializedName("citation")
  private String citation = null;

  @SerializedName("custom_fields")
  private List<CustomArticleField> customFields = new ArrayList<CustomArticleField>();

  @SerializedName("modified_date")
  private String modifiedDate = null;

  @SerializedName("created_date")
  private String createdDate = null;

  public CollectionCompletePrivate id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Collection id
   * @return id
  **/
  @ApiModelProperty(example = "123", required = true, value = "Collection id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public CollectionCompletePrivate title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Collection title
   * @return title
  **/
  @ApiModelProperty(example = "Sample collection", required = true, value = "Collection title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public CollectionCompletePrivate doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * Collection DOI
   * @return doi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.123", required = true, value = "Collection DOI")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public CollectionCompletePrivate handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Collection Handle
   * @return handle
  **/
  @ApiModelProperty(example = "111184/figshare.1234", required = true, value = "Collection Handle")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public CollectionCompletePrivate url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Api endpoint
   * @return url
  **/
  @ApiModelProperty(example = "https://api.figshare.com/v2/collections/123", required = true, value = "Api endpoint")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public CollectionCompletePrivate timeline(Timeline timeline) {
    this.timeline = timeline;
    return this;
  }

   /**
   * Various timeline dates
   * @return timeline
  **/
  @ApiModelProperty(required = true, value = "Various timeline dates")
  public Timeline getTimeline() {
    return timeline;
  }

  public void setTimeline(Timeline timeline) {
    this.timeline = timeline;
  }

  public CollectionCompletePrivate accountId(Long accountId) {
    this.accountId = accountId;
    return this;
  }

   /**
   * ID of the account owning the collection
   * @return accountId
  **/
  @ApiModelProperty(example = "1000001", required = true, value = "ID of the account owning the collection")
  public Long getAccountId() {
    return accountId;
  }

  public void setAccountId(Long accountId) {
    this.accountId = accountId;
  }

  public CollectionCompletePrivate funding(List<FundingInformation> funding) {
    this.funding = funding;
    return this;
  }

  public CollectionCompletePrivate addFundingItem(FundingInformation fundingItem) {
    this.funding.add(fundingItem);
    return this;
  }

   /**
   * Full Collection funding information
   * @return funding
  **/
  @ApiModelProperty(required = true, value = "Full Collection funding information")
  public List<FundingInformation> getFunding() {
    return funding;
  }

  public void setFunding(List<FundingInformation> funding) {
    this.funding = funding;
  }

  public CollectionCompletePrivate resourceId(String resourceId) {
    this.resourceId = resourceId;
    return this;
  }

   /**
   * Collection resource id
   * @return resourceId
  **/
  @ApiModelProperty(example = "", required = true, value = "Collection resource id")
  public String getResourceId() {
    return resourceId;
  }

  public void setResourceId(String resourceId) {
    this.resourceId = resourceId;
  }

  public CollectionCompletePrivate resourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
    return this;
  }

   /**
   * Collection resource doi
   * @return resourceDoi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.123", required = true, value = "Collection resource doi")
  public String getResourceDoi() {
    return resourceDoi;
  }

  public void setResourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
  }

  public CollectionCompletePrivate resourceTitle(String resourceTitle) {
    this.resourceTitle = resourceTitle;
    return this;
  }

   /**
   * Collection resource title
   * @return resourceTitle
  **/
  @ApiModelProperty(example = "test", required = true, value = "Collection resource title")
  public String getResourceTitle() {
    return resourceTitle;
  }

  public void setResourceTitle(String resourceTitle) {
    this.resourceTitle = resourceTitle;
  }

  public CollectionCompletePrivate resourceLink(String resourceLink) {
    this.resourceLink = resourceLink;
    return this;
  }

   /**
   * Collection resource link
   * @return resourceLink
  **/
  @ApiModelProperty(example = "http://figshare.com", required = true, value = "Collection resource link")
  public String getResourceLink() {
    return resourceLink;
  }

  public void setResourceLink(String resourceLink) {
    this.resourceLink = resourceLink;
  }

  public CollectionCompletePrivate resourceVersion(Long resourceVersion) {
    this.resourceVersion = resourceVersion;
    return this;
  }

   /**
   * Collection resource version
   * @return resourceVersion
  **/
  @ApiModelProperty(example = "0", required = true, value = "Collection resource version")
  public Long getResourceVersion() {
    return resourceVersion;
  }

  public void setResourceVersion(Long resourceVersion) {
    this.resourceVersion = resourceVersion;
  }

  public CollectionCompletePrivate version(Long version) {
    this.version = version;
    return this;
  }

   /**
   * Collection version
   * @return version
  **/
  @ApiModelProperty(example = "1", required = true, value = "Collection version")
  public Long getVersion() {
    return version;
  }

  public void setVersion(Long version) {
    this.version = version;
  }

  public CollectionCompletePrivate description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Collection description
   * @return description
  **/
  @ApiModelProperty(example = "description", required = true, value = "Collection description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public CollectionCompletePrivate categories(List<Category> categories) {
    this.categories = categories;
    return this;
  }

  public CollectionCompletePrivate addCategoriesItem(Category categoriesItem) {
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * List of collection categories
   * @return categories
  **/
  @ApiModelProperty(required = true, value = "List of collection categories")
  public List<Category> getCategories() {
    return categories;
  }

  public void setCategories(List<Category> categories) {
    this.categories = categories;
  }

  public CollectionCompletePrivate references(List<String> references) {
    this.references = references;
    return this;
  }

  public CollectionCompletePrivate addReferencesItem(String referencesItem) {
    this.references.add(referencesItem);
    return this;
  }

   /**
   * List of collection references
   * @return references
  **/
  @ApiModelProperty(required = true, value = "List of collection references")
  public List<String> getReferences() {
    return references;
  }

  public void setReferences(List<String> references) {
    this.references = references;
  }

  public CollectionCompletePrivate tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public CollectionCompletePrivate addTagsItem(String tagsItem) {
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * List of collection tags
   * @return tags
  **/
  @ApiModelProperty(example = "[\"t1\",\"t2\"]", required = true, value = "List of collection tags")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public CollectionCompletePrivate authors(List<Author> authors) {
    this.authors = authors;
    return this;
  }

  public CollectionCompletePrivate addAuthorsItem(Author authorsItem) {
    this.authors.add(authorsItem);
    return this;
  }

   /**
   * List of collection authors
   * @return authors
  **/
  @ApiModelProperty(required = true, value = "List of collection authors")
  public List<Author> getAuthors() {
    return authors;
  }

  public void setAuthors(List<Author> authors) {
    this.authors = authors;
  }

  public CollectionCompletePrivate institutionId(Long institutionId) {
    this.institutionId = institutionId;
    return this;
  }

   /**
   * Collection institution
   * @return institutionId
  **/
  @ApiModelProperty(example = "1", required = true, value = "Collection institution")
  public Long getInstitutionId() {
    return institutionId;
  }

  public void setInstitutionId(Long institutionId) {
    this.institutionId = institutionId;
  }

  public CollectionCompletePrivate groupId(Long groupId) {
    this.groupId = groupId;
    return this;
  }

   /**
   * Collection group
   * @return groupId
  **/
  @ApiModelProperty(example = "1", required = true, value = "Collection group")
  public Long getGroupId() {
    return groupId;
  }

  public void setGroupId(Long groupId) {
    this.groupId = groupId;
  }

  public CollectionCompletePrivate articlesCount(Long articlesCount) {
    this.articlesCount = articlesCount;
    return this;
  }

   /**
   * Number of articles in collection
   * @return articlesCount
  **/
  @ApiModelProperty(example = "1", required = true, value = "Number of articles in collection")
  public Long getArticlesCount() {
    return articlesCount;
  }

  public void setArticlesCount(Long articlesCount) {
    this.articlesCount = articlesCount;
  }

  public CollectionCompletePrivate _public(Boolean _public) {
    this._public = _public;
    return this;
  }

   /**
   * True if collection is published
   * @return _public
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if collection is published")
  public Boolean isPublic() {
    return _public;
  }

  public void setPublic(Boolean _public) {
    this._public = _public;
  }

  public CollectionCompletePrivate citation(String citation) {
    this.citation = citation;
    return this;
  }

   /**
   * Collection citation
   * @return citation
  **/
  @ApiModelProperty(example = "citation", required = true, value = "Collection citation")
  public String getCitation() {
    return citation;
  }

  public void setCitation(String citation) {
    this.citation = citation;
  }

  public CollectionCompletePrivate customFields(List<CustomArticleField> customFields) {
    this.customFields = customFields;
    return this;
  }

  public CollectionCompletePrivate addCustomFieldsItem(CustomArticleField customFieldsItem) {
    this.customFields.add(customFieldsItem);
    return this;
  }

   /**
   * Collection custom fields
   * @return customFields
  **/
  @ApiModelProperty(required = true, value = "Collection custom fields")
  public List<CustomArticleField> getCustomFields() {
    return customFields;
  }

  public void setCustomFields(List<CustomArticleField> customFields) {
    this.customFields = customFields;
  }

  public CollectionCompletePrivate modifiedDate(String modifiedDate) {
    this.modifiedDate = modifiedDate;
    return this;
  }

   /**
   * Date when collection was last modified
   * @return modifiedDate
  **/
  @ApiModelProperty(example = "2017-05-15T15:12:26Z", required = true, value = "Date when collection was last modified")
  public String getModifiedDate() {
    return modifiedDate;
  }

  public void setModifiedDate(String modifiedDate) {
    this.modifiedDate = modifiedDate;
  }

  public CollectionCompletePrivate createdDate(String createdDate) {
    this.createdDate = createdDate;
    return this;
  }

   /**
   * Date when collection was created
   * @return createdDate
  **/
  @ApiModelProperty(example = "2017-05-15T15:12:26Z", required = true, value = "Date when collection was created")
  public String getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(String createdDate) {
    this.createdDate = createdDate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CollectionCompletePrivate collectionCompletePrivate = (CollectionCompletePrivate) o;
    return Objects.equals(this.id, collectionCompletePrivate.id) &&
        Objects.equals(this.title, collectionCompletePrivate.title) &&
        Objects.equals(this.doi, collectionCompletePrivate.doi) &&
        Objects.equals(this.handle, collectionCompletePrivate.handle) &&
        Objects.equals(this.url, collectionCompletePrivate.url) &&
        Objects.equals(this.timeline, collectionCompletePrivate.timeline) &&
        Objects.equals(this.accountId, collectionCompletePrivate.accountId) &&
        Objects.equals(this.funding, collectionCompletePrivate.funding) &&
        Objects.equals(this.resourceId, collectionCompletePrivate.resourceId) &&
        Objects.equals(this.resourceDoi, collectionCompletePrivate.resourceDoi) &&
        Objects.equals(this.resourceTitle, collectionCompletePrivate.resourceTitle) &&
        Objects.equals(this.resourceLink, collectionCompletePrivate.resourceLink) &&
        Objects.equals(this.resourceVersion, collectionCompletePrivate.resourceVersion) &&
        Objects.equals(this.version, collectionCompletePrivate.version) &&
        Objects.equals(this.description, collectionCompletePrivate.description) &&
        Objects.equals(this.categories, collectionCompletePrivate.categories) &&
        Objects.equals(this.references, collectionCompletePrivate.references) &&
        Objects.equals(this.tags, collectionCompletePrivate.tags) &&
        Objects.equals(this.authors, collectionCompletePrivate.authors) &&
        Objects.equals(this.institutionId, collectionCompletePrivate.institutionId) &&
        Objects.equals(this.groupId, collectionCompletePrivate.groupId) &&
        Objects.equals(this.articlesCount, collectionCompletePrivate.articlesCount) &&
        Objects.equals(this._public, collectionCompletePrivate._public) &&
        Objects.equals(this.citation, collectionCompletePrivate.citation) &&
        Objects.equals(this.customFields, collectionCompletePrivate.customFields) &&
        Objects.equals(this.modifiedDate, collectionCompletePrivate.modifiedDate) &&
        Objects.equals(this.createdDate, collectionCompletePrivate.createdDate) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, title, doi, handle, url, timeline, accountId, funding, resourceId, resourceDoi, resourceTitle, resourceLink, resourceVersion, version, description, categories, references, tags, authors, institutionId, groupId, articlesCount, _public, citation, customFields, modifiedDate, createdDate, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CollectionCompletePrivate {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    timeline: ").append(toIndentedString(timeline)).append("\n");
    sb.append("    accountId: ").append(toIndentedString(accountId)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    resourceId: ").append(toIndentedString(resourceId)).append("\n");
    sb.append("    resourceDoi: ").append(toIndentedString(resourceDoi)).append("\n");
    sb.append("    resourceTitle: ").append(toIndentedString(resourceTitle)).append("\n");
    sb.append("    resourceLink: ").append(toIndentedString(resourceLink)).append("\n");
    sb.append("    resourceVersion: ").append(toIndentedString(resourceVersion)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    authors: ").append(toIndentedString(authors)).append("\n");
    sb.append("    institutionId: ").append(toIndentedString(institutionId)).append("\n");
    sb.append("    groupId: ").append(toIndentedString(groupId)).append("\n");
    sb.append("    articlesCount: ").append(toIndentedString(articlesCount)).append("\n");
    sb.append("    _public: ").append(toIndentedString(_public)).append("\n");
    sb.append("    citation: ").append(toIndentedString(citation)).append("\n");
    sb.append("    customFields: ").append(toIndentedString(customFields)).append("\n");
    sb.append("    modifiedDate: ").append(toIndentedString(modifiedDate)).append("\n");
    sb.append("    createdDate: ").append(toIndentedString(createdDate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

