/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.CustomArticleFieldAdd;
import io.swagger.client.model.FundingCreate;
import io.swagger.client.model.TimelineUpdate;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * CollectionCreate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-29T12:13:04.813Z")
public class CollectionCreate {
  @SerializedName("funding")
  private String funding = "";

  @SerializedName("funding_list")
  private List<FundingCreate> fundingList = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("description")
  private String description = "";

  @SerializedName("articles")
  private List<Integer> articles = null;

  @SerializedName("authors")
  private List<Object> authors = null;

  @SerializedName("categories")
  private List<Long> categories = null;

  @SerializedName("categories_by_source_id")
  private List<String> categoriesBySourceId = null;

  @SerializedName("tags")
  private List<String> tags = null;

  @SerializedName("keywords")
  private List<String> keywords = null;

  @SerializedName("references")
  private List<String> references = null;

  @SerializedName("custom_fields")
  private Object customFields = null;

  @SerializedName("custom_fields_list")
  private List<CustomArticleFieldAdd> customFieldsList = null;

  @SerializedName("doi")
  private String doi = "";

  @SerializedName("handle")
  private String handle = "";

  @SerializedName("resource_id")
  private String resourceId = null;

  @SerializedName("resource_doi")
  private String resourceDoi = "";

  @SerializedName("resource_link")
  private String resourceLink = null;

  @SerializedName("resource_title")
  private String resourceTitle = "";

  @SerializedName("resource_version")
  private Integer resourceVersion = null;

  @SerializedName("group_id")
  private Long groupId = null;

  @SerializedName("timeline")
  private TimelineUpdate timeline = null;

  public CollectionCreate funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Grant number or funding authority
   * @return funding
  **/
  @ApiModelProperty(value = "Grant number or funding authority")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public CollectionCreate fundingList(List<FundingCreate> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public CollectionCreate addFundingListItem(FundingCreate fundingListItem) {
    if (this.fundingList == null) {
      this.fundingList = new ArrayList<FundingCreate>();
    }
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Funding creation / update items
   * @return fundingList
  **/
  @ApiModelProperty(value = "Funding creation / update items")
  public List<FundingCreate> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingCreate> fundingList) {
    this.fundingList = fundingList;
  }

  public CollectionCreate title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Title of collection
   * @return title
  **/
  @ApiModelProperty(example = "Test collection title", required = true, value = "Title of collection")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public CollectionCreate description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The collection description. In a publisher case, usually this is the remote collection description
   * @return description
  **/
  @ApiModelProperty(example = "Test description of article", value = "The collection description. In a publisher case, usually this is the remote collection description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public CollectionCreate articles(List<Integer> articles) {
    this.articles = articles;
    return this;
  }

  public CollectionCreate addArticlesItem(Integer articlesItem) {
    if (this.articles == null) {
      this.articles = new ArrayList<Integer>();
    }
    this.articles.add(articlesItem);
    return this;
  }

   /**
   * List of articles to be associated with the collection
   * @return articles
  **/
  @ApiModelProperty(example = "[2000001,2000005]", value = "List of articles to be associated with the collection")
  public List<Integer> getArticles() {
    return articles;
  }

  public void setArticles(List<Integer> articles) {
    this.articles = articles;
  }

  public CollectionCreate authors(List<Object> authors) {
    this.authors = authors;
    return this;
  }

  public CollectionCreate addAuthorsItem(Object authorsItem) {
    if (this.authors == null) {
      this.authors = new ArrayList<Object>();
    }
    this.authors.add(authorsItem);
    return this;
  }

   /**
   * List of authors to be associated with the collection. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.
   * @return authors
  **/
  @ApiModelProperty(example = "[{\"name\":\"John Doe\"},{\"id\":20005}]", value = "List of authors to be associated with the collection. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.")
  public List<Object> getAuthors() {
    return authors;
  }

  public void setAuthors(List<Object> authors) {
    this.authors = authors;
  }

  public CollectionCreate categories(List<Long> categories) {
    this.categories = categories;
    return this;
  }

  public CollectionCreate addCategoriesItem(Long categoriesItem) {
    if (this.categories == null) {
      this.categories = new ArrayList<Long>();
    }
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * List of category ids to be associated with the collection(e.g [1, 23, 33, 66])
   * @return categories
  **/
  @ApiModelProperty(example = "[1,10,11]", value = "List of category ids to be associated with the collection(e.g [1, 23, 33, 66])")
  public List<Long> getCategories() {
    return categories;
  }

  public void setCategories(List<Long> categories) {
    this.categories = categories;
  }

  public CollectionCreate categoriesBySourceId(List<String> categoriesBySourceId) {
    this.categoriesBySourceId = categoriesBySourceId;
    return this;
  }

  public CollectionCreate addCategoriesBySourceIdItem(String categoriesBySourceIdItem) {
    if (this.categoriesBySourceId == null) {
      this.categoriesBySourceId = new ArrayList<String>();
    }
    this.categoriesBySourceId.add(categoriesBySourceIdItem);
    return this;
  }

   /**
   * List of category source ids to be associated with the collection, supersedes the categories property
   * @return categoriesBySourceId
  **/
  @ApiModelProperty(example = "[\"300204\",\"400207\"]", value = "List of category source ids to be associated with the collection, supersedes the categories property")
  public List<String> getCategoriesBySourceId() {
    return categoriesBySourceId;
  }

  public void setCategoriesBySourceId(List<String> categoriesBySourceId) {
    this.categoriesBySourceId = categoriesBySourceId;
  }

  public CollectionCreate tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public CollectionCreate addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * List of tags to be associated with the collection. Keywords can be used instead
   * @return tags
  **/
  @ApiModelProperty(example = "[\"tag1\",\"tag2\"]", value = "List of tags to be associated with the collection. Keywords can be used instead")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public CollectionCreate keywords(List<String> keywords) {
    this.keywords = keywords;
    return this;
  }

  public CollectionCreate addKeywordsItem(String keywordsItem) {
    if (this.keywords == null) {
      this.keywords = new ArrayList<String>();
    }
    this.keywords.add(keywordsItem);
    return this;
  }

   /**
   * List of tags to be associated with the collection. Tags can be used instead
   * @return keywords
  **/
  @ApiModelProperty(example = "[\"tag1\",\"tag2\"]", value = "List of tags to be associated with the collection. Tags can be used instead")
  public List<String> getKeywords() {
    return keywords;
  }

  public void setKeywords(List<String> keywords) {
    this.keywords = keywords;
  }

  public CollectionCreate references(List<String> references) {
    this.references = references;
    return this;
  }

  public CollectionCreate addReferencesItem(String referencesItem) {
    if (this.references == null) {
      this.references = new ArrayList<String>();
    }
    this.references.add(referencesItem);
    return this;
  }

   /**
   * List of links to be associated with the collection (e.g [\&quot;http://link1\&quot;, \&quot;http://link2\&quot;, \&quot;http://link3\&quot;])
   * @return references
  **/
  @ApiModelProperty(example = "[\"http://figshare.com\",\"http://api.figshare.com\"]", value = "List of links to be associated with the collection (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])")
  public List<String> getReferences() {
    return references;
  }

  public void setReferences(List<String> references) {
    this.references = references;
  }

  public CollectionCreate customFields(Object customFields) {
    this.customFields = customFields;
    return this;
  }

   /**
   * List of key, values pairs to be associated with the collection
   * @return customFields
  **/
  @ApiModelProperty(example = "{\"defined_key\":\"value for it\"}", value = "List of key, values pairs to be associated with the collection")
  public Object getCustomFields() {
    return customFields;
  }

  public void setCustomFields(Object customFields) {
    this.customFields = customFields;
  }

  public CollectionCreate customFieldsList(List<CustomArticleFieldAdd> customFieldsList) {
    this.customFieldsList = customFieldsList;
    return this;
  }

  public CollectionCreate addCustomFieldsListItem(CustomArticleFieldAdd customFieldsListItem) {
    if (this.customFieldsList == null) {
      this.customFieldsList = new ArrayList<CustomArticleFieldAdd>();
    }
    this.customFieldsList.add(customFieldsListItem);
    return this;
  }

   /**
   * List of custom fields values, supersedes custom_fields parameter
   * @return customFieldsList
  **/
  @ApiModelProperty(value = "List of custom fields values, supersedes custom_fields parameter")
  public List<CustomArticleFieldAdd> getCustomFieldsList() {
    return customFieldsList;
  }

  public void setCustomFieldsList(List<CustomArticleFieldAdd> customFieldsList) {
    this.customFieldsList = customFieldsList;
  }

  public CollectionCreate doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
   * @return doi
  **/
  @ApiModelProperty(value = "Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public CollectionCreate handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
   * @return handle
  **/
  @ApiModelProperty(value = "Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public CollectionCreate resourceId(String resourceId) {
    this.resourceId = resourceId;
    return this;
  }

   /**
   * Not applicable to regular users. In a publisher case, this is the publisher article id
   * @return resourceId
  **/
  @ApiModelProperty(value = "Not applicable to regular users. In a publisher case, this is the publisher article id")
  public String getResourceId() {
    return resourceId;
  }

  public void setResourceId(String resourceId) {
    this.resourceId = resourceId;
  }

  public CollectionCreate resourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
    return this;
  }

   /**
   * Not applicable to regular users. In a publisher case, this is the publisher article DOI.
   * @return resourceDoi
  **/
  @ApiModelProperty(value = "Not applicable to regular users. In a publisher case, this is the publisher article DOI.")
  public String getResourceDoi() {
    return resourceDoi;
  }

  public void setResourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
  }

  public CollectionCreate resourceLink(String resourceLink) {
    this.resourceLink = resourceLink;
    return this;
  }

   /**
   * Not applicable to regular users. In a publisher case, this is the publisher article link
   * @return resourceLink
  **/
  @ApiModelProperty(value = "Not applicable to regular users. In a publisher case, this is the publisher article link")
  public String getResourceLink() {
    return resourceLink;
  }

  public void setResourceLink(String resourceLink) {
    this.resourceLink = resourceLink;
  }

  public CollectionCreate resourceTitle(String resourceTitle) {
    this.resourceTitle = resourceTitle;
    return this;
  }

   /**
   * Not applicable to regular users. In a publisher case, this is the publisher article title.
   * @return resourceTitle
  **/
  @ApiModelProperty(value = "Not applicable to regular users. In a publisher case, this is the publisher article title.")
  public String getResourceTitle() {
    return resourceTitle;
  }

  public void setResourceTitle(String resourceTitle) {
    this.resourceTitle = resourceTitle;
  }

  public CollectionCreate resourceVersion(Integer resourceVersion) {
    this.resourceVersion = resourceVersion;
    return this;
  }

   /**
   * Not applicable to regular users. In a publisher case, this is the publisher article version
   * @return resourceVersion
  **/
  @ApiModelProperty(value = "Not applicable to regular users. In a publisher case, this is the publisher article version")
  public Integer getResourceVersion() {
    return resourceVersion;
  }

  public void setResourceVersion(Integer resourceVersion) {
    this.resourceVersion = resourceVersion;
  }

  public CollectionCreate groupId(Long groupId) {
    this.groupId = groupId;
    return this;
  }

   /**
   * Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups
   * @return groupId
  **/
  @ApiModelProperty(value = "Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups")
  public Long getGroupId() {
    return groupId;
  }

  public void setGroupId(Long groupId) {
    this.groupId = groupId;
  }

  public CollectionCreate timeline(TimelineUpdate timeline) {
    this.timeline = timeline;
    return this;
  }

   /**
   * Various timeline dates
   * @return timeline
  **/
  @ApiModelProperty(value = "Various timeline dates")
  public TimelineUpdate getTimeline() {
    return timeline;
  }

  public void setTimeline(TimelineUpdate timeline) {
    this.timeline = timeline;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CollectionCreate collectionCreate = (CollectionCreate) o;
    return Objects.equals(this.funding, collectionCreate.funding) &&
        Objects.equals(this.fundingList, collectionCreate.fundingList) &&
        Objects.equals(this.title, collectionCreate.title) &&
        Objects.equals(this.description, collectionCreate.description) &&
        Objects.equals(this.articles, collectionCreate.articles) &&
        Objects.equals(this.authors, collectionCreate.authors) &&
        Objects.equals(this.categories, collectionCreate.categories) &&
        Objects.equals(this.categoriesBySourceId, collectionCreate.categoriesBySourceId) &&
        Objects.equals(this.tags, collectionCreate.tags) &&
        Objects.equals(this.keywords, collectionCreate.keywords) &&
        Objects.equals(this.references, collectionCreate.references) &&
        Objects.equals(this.customFields, collectionCreate.customFields) &&
        Objects.equals(this.customFieldsList, collectionCreate.customFieldsList) &&
        Objects.equals(this.doi, collectionCreate.doi) &&
        Objects.equals(this.handle, collectionCreate.handle) &&
        Objects.equals(this.resourceId, collectionCreate.resourceId) &&
        Objects.equals(this.resourceDoi, collectionCreate.resourceDoi) &&
        Objects.equals(this.resourceLink, collectionCreate.resourceLink) &&
        Objects.equals(this.resourceTitle, collectionCreate.resourceTitle) &&
        Objects.equals(this.resourceVersion, collectionCreate.resourceVersion) &&
        Objects.equals(this.groupId, collectionCreate.groupId) &&
        Objects.equals(this.timeline, collectionCreate.timeline);
  }

  @Override
  public int hashCode() {
    return Objects.hash(funding, fundingList, title, description, articles, authors, categories, categoriesBySourceId, tags, keywords, references, customFields, customFieldsList, doi, handle, resourceId, resourceDoi, resourceLink, resourceTitle, resourceVersion, groupId, timeline);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CollectionCreate {\n");
    
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    articles: ").append(toIndentedString(articles)).append("\n");
    sb.append("    authors: ").append(toIndentedString(authors)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    categoriesBySourceId: ").append(toIndentedString(categoriesBySourceId)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    keywords: ").append(toIndentedString(keywords)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    customFields: ").append(toIndentedString(customFields)).append("\n");
    sb.append("    customFieldsList: ").append(toIndentedString(customFieldsList)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    resourceId: ").append(toIndentedString(resourceId)).append("\n");
    sb.append("    resourceDoi: ").append(toIndentedString(resourceDoi)).append("\n");
    sb.append("    resourceLink: ").append(toIndentedString(resourceLink)).append("\n");
    sb.append("    resourceTitle: ").append(toIndentedString(resourceTitle)).append("\n");
    sb.append("    resourceVersion: ").append(toIndentedString(resourceVersion)).append("\n");
    sb.append("    groupId: ").append(toIndentedString(groupId)).append("\n");
    sb.append("    timeline: ").append(toIndentedString(timeline)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

