/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.CollectionSearch;
import java.io.IOException;

/**
 * PrivateCollectionSearch
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-29T12:13:04.813Z")
public class PrivateCollectionSearch extends CollectionSearch {
  @SerializedName("resource_doi")
  private String resourceDoi = null;

  @SerializedName("doi")
  private String doi = null;

  @SerializedName("handle")
  private String handle = null;

  @SerializedName("search_for")
  private String searchFor = null;

  @SerializedName("page")
  private Long page = null;

  @SerializedName("page_size")
  private Long pageSize = 10l;

  @SerializedName("limit")
  private Long limit = null;

  @SerializedName("offset")
  private Long offset = null;

  /**
   * Direction of ordering
   */
  @JsonAdapter(OrderDirectionEnum.Adapter.class)
  public enum OrderDirectionEnum {
    ASC("asc"),
    
    DESC("desc");

    private String value;

    OrderDirectionEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static OrderDirectionEnum fromValue(String text) {
      for (OrderDirectionEnum b : OrderDirectionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<OrderDirectionEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final OrderDirectionEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public OrderDirectionEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return OrderDirectionEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("order_direction")
  private OrderDirectionEnum orderDirection = OrderDirectionEnum.DESC;

  @SerializedName("institution")
  private Integer institution = null;

  @SerializedName("published_since")
  private String publishedSince = null;

  @SerializedName("modified_since")
  private String modifiedSince = null;

  @SerializedName("group")
  private Integer group = null;

  @SerializedName("resource_id")
  private String resourceId = null;

  public PrivateCollectionSearch resourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
    return this;
  }

   /**
   * Only return collections with this resource_doi
   * @return resourceDoi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.1407024", value = "Only return collections with this resource_doi")
  public String getResourceDoi() {
    return resourceDoi;
  }

  public void setResourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
  }

  public PrivateCollectionSearch doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * Only return collections with this doi
   * @return doi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.1407024", value = "Only return collections with this doi")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public PrivateCollectionSearch handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Only return collections with this handle
   * @return handle
  **/
  @ApiModelProperty(example = "10084/figshare.1407024", value = "Only return collections with this handle")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public PrivateCollectionSearch searchFor(String searchFor) {
    this.searchFor = searchFor;
    return this;
  }

   /**
   * Search term
   * @return searchFor
  **/
  @ApiModelProperty(example = "figshare", value = "Search term")
  public String getSearchFor() {
    return searchFor;
  }

  public void setSearchFor(String searchFor) {
    this.searchFor = searchFor;
  }

  public PrivateCollectionSearch page(Long page) {
    this.page = page;
    return this;
  }

   /**
   * Page number. Used for pagination with page_size
   * minimum: 1
   * maximum: 5000
   * @return page
  **/
  @ApiModelProperty(example = "1", value = "Page number. Used for pagination with page_size")
  public Long getPage() {
    return page;
  }

  public void setPage(Long page) {
    this.page = page;
  }

  public PrivateCollectionSearch pageSize(Long pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * The number of results included on a page. Used for pagination with page
   * minimum: 1
   * maximum: 1000
   * @return pageSize
  **/
  @ApiModelProperty(example = "10", value = "The number of results included on a page. Used for pagination with page")
  public Long getPageSize() {
    return pageSize;
  }

  public void setPageSize(Long pageSize) {
    this.pageSize = pageSize;
  }

  public PrivateCollectionSearch limit(Long limit) {
    this.limit = limit;
    return this;
  }

   /**
   * Number of results included on a page. Used for pagination with query
   * minimum: 1
   * maximum: 1000
   * @return limit
  **/
  @ApiModelProperty(example = "10", value = "Number of results included on a page. Used for pagination with query")
  public Long getLimit() {
    return limit;
  }

  public void setLimit(Long limit) {
    this.limit = limit;
  }

  public PrivateCollectionSearch offset(Long offset) {
    this.offset = offset;
    return this;
  }

   /**
   * Where to start the listing(the offset of the first result). Used for pagination with limit
   * minimum: 0
   * maximum: 5000
   * @return offset
  **/
  @ApiModelProperty(example = "0", value = "Where to start the listing(the offset of the first result). Used for pagination with limit")
  public Long getOffset() {
    return offset;
  }

  public void setOffset(Long offset) {
    this.offset = offset;
  }

  public PrivateCollectionSearch orderDirection(OrderDirectionEnum orderDirection) {
    this.orderDirection = orderDirection;
    return this;
  }

   /**
   * Direction of ordering
   * @return orderDirection
  **/
  @ApiModelProperty(example = "desc", value = "Direction of ordering")
  public OrderDirectionEnum getOrderDirection() {
    return orderDirection;
  }

  public void setOrderDirection(OrderDirectionEnum orderDirection) {
    this.orderDirection = orderDirection;
  }

  public PrivateCollectionSearch institution(Integer institution) {
    this.institution = institution;
    return this;
  }

   /**
   * only return collections from this institution
   * @return institution
  **/
  @ApiModelProperty(example = "2000013", value = "only return collections from this institution")
  public Integer getInstitution() {
    return institution;
  }

  public void setInstitution(Integer institution) {
    this.institution = institution;
  }

  public PrivateCollectionSearch publishedSince(String publishedSince) {
    this.publishedSince = publishedSince;
    return this;
  }

   /**
   * Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @return publishedSince
  **/
  @ApiModelProperty(example = "2017-12-22", value = "Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD")
  public String getPublishedSince() {
    return publishedSince;
  }

  public void setPublishedSince(String publishedSince) {
    this.publishedSince = publishedSince;
  }

  public PrivateCollectionSearch modifiedSince(String modifiedSince) {
    this.modifiedSince = modifiedSince;
    return this;
  }

   /**
   * Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @return modifiedSince
  **/
  @ApiModelProperty(example = "2017-12-22", value = "Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD")
  public String getModifiedSince() {
    return modifiedSince;
  }

  public void setModifiedSince(String modifiedSince) {
    this.modifiedSince = modifiedSince;
  }

  public PrivateCollectionSearch group(Integer group) {
    this.group = group;
    return this;
  }

   /**
   * only return collections from this group
   * @return group
  **/
  @ApiModelProperty(example = "2000013", value = "only return collections from this group")
  public Integer getGroup() {
    return group;
  }

  public void setGroup(Integer group) {
    this.group = group;
  }

  public PrivateCollectionSearch resourceId(String resourceId) {
    this.resourceId = resourceId;
    return this;
  }

   /**
   * only return collections with this resource_id
   * @return resourceId
  **/
  @ApiModelProperty(example = "1407024", value = "only return collections with this resource_id")
  public String getResourceId() {
    return resourceId;
  }

  public void setResourceId(String resourceId) {
    this.resourceId = resourceId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PrivateCollectionSearch privateCollectionSearch = (PrivateCollectionSearch) o;
    return Objects.equals(this.resourceDoi, privateCollectionSearch.resourceDoi) &&
        Objects.equals(this.doi, privateCollectionSearch.doi) &&
        Objects.equals(this.handle, privateCollectionSearch.handle) &&
        Objects.equals(this.searchFor, privateCollectionSearch.searchFor) &&
        Objects.equals(this.page, privateCollectionSearch.page) &&
        Objects.equals(this.pageSize, privateCollectionSearch.pageSize) &&
        Objects.equals(this.limit, privateCollectionSearch.limit) &&
        Objects.equals(this.offset, privateCollectionSearch.offset) &&
        Objects.equals(this.orderDirection, privateCollectionSearch.orderDirection) &&
        Objects.equals(this.institution, privateCollectionSearch.institution) &&
        Objects.equals(this.publishedSince, privateCollectionSearch.publishedSince) &&
        Objects.equals(this.modifiedSince, privateCollectionSearch.modifiedSince) &&
        Objects.equals(this.group, privateCollectionSearch.group) &&
        Objects.equals(this.resourceId, privateCollectionSearch.resourceId) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(resourceDoi, doi, handle, searchFor, page, pageSize, limit, offset, orderDirection, institution, publishedSince, modifiedSince, group, resourceId, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PrivateCollectionSearch {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    resourceDoi: ").append(toIndentedString(resourceDoi)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    searchFor: ").append(toIndentedString(searchFor)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    offset: ").append(toIndentedString(offset)).append("\n");
    sb.append("    orderDirection: ").append(toIndentedString(orderDirection)).append("\n");
    sb.append("    institution: ").append(toIndentedString(institution)).append("\n");
    sb.append("    publishedSince: ").append(toIndentedString(publishedSince)).append("\n");
    sb.append("    modifiedSince: ").append(toIndentedString(modifiedSince)).append("\n");
    sb.append("    group: ").append(toIndentedString(group)).append("\n");
    sb.append("    resourceId: ").append(toIndentedString(resourceId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

