/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Collaborator;
import io.swagger.client.model.CustomArticleField;
import io.swagger.client.model.FundingInformation;
import io.swagger.client.model.ProjectPrivate;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ProjectCompletePrivate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-29T12:13:04.813Z")
public class ProjectCompletePrivate extends ProjectPrivate {
  /**
   * Role inside this project
   */
  @JsonAdapter(RoleEnum.Adapter.class)
  public enum RoleEnum {
    OWNER("Owner"),
    
    COLLABORATOR("Collaborator"),
    
    VIEWER("Viewer");

    private String value;

    RoleEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static RoleEnum fromValue(String text) {
      for (RoleEnum b : RoleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<RoleEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final RoleEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public RoleEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return RoleEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("role")
  private RoleEnum role = null;

  /**
   * Project storage type
   */
  @JsonAdapter(StorageEnum.Adapter.class)
  public enum StorageEnum {
    INDIVIDUAL("individual"),
    
    GROUP("group");

    private String value;

    StorageEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static StorageEnum fromValue(String text) {
      for (StorageEnum b : StorageEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<StorageEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StorageEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public StorageEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return StorageEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("storage")
  private StorageEnum storage = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("id")
  private Long id = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("funding")
  private String funding = null;

  @SerializedName("funding_list")
  private List<FundingInformation> fundingList = new ArrayList<FundingInformation>();

  @SerializedName("description")
  private String description = null;

  @SerializedName("collaborators")
  private List<Collaborator> collaborators = new ArrayList<Collaborator>();

  @SerializedName("quota")
  private Long quota = null;

  @SerializedName("used_quota")
  private Long usedQuota = null;

  @SerializedName("created_date")
  private String createdDate = null;

  @SerializedName("modified_date")
  private String modifiedDate = null;

  @SerializedName("used_quota_private")
  private Long usedQuotaPrivate = null;

  @SerializedName("used_quota_public")
  private Long usedQuotaPublic = null;

  @SerializedName("group_id")
  private Long groupId = null;

  @SerializedName("account_id")
  private Long accountId = null;

  @SerializedName("custom_fields")
  private List<CustomArticleField> customFields = new ArrayList<CustomArticleField>();

  public ProjectCompletePrivate role(RoleEnum role) {
    this.role = role;
    return this;
  }

   /**
   * Role inside this project
   * @return role
  **/
  @ApiModelProperty(example = "Owner", value = "Role inside this project")
  public RoleEnum getRole() {
    return role;
  }

  public void setRole(RoleEnum role) {
    this.role = role;
  }

  public ProjectCompletePrivate storage(StorageEnum storage) {
    this.storage = storage;
    return this;
  }

   /**
   * Project storage type
   * @return storage
  **/
  @ApiModelProperty(example = "individual", value = "Project storage type")
  public StorageEnum getStorage() {
    return storage;
  }

  public void setStorage(StorageEnum storage) {
    this.storage = storage;
  }

  public ProjectCompletePrivate url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Api endpoint
   * @return url
  **/
  @ApiModelProperty(example = "http://api.figshare.com/v2/account/projects/1", required = true, value = "Api endpoint")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ProjectCompletePrivate id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Project id
   * @return id
  **/
  @ApiModelProperty(example = "1", required = true, value = "Project id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ProjectCompletePrivate title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Project title
   * @return title
  **/
  @ApiModelProperty(example = "project", required = true, value = "Project title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ProjectCompletePrivate funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Project funding
   * @return funding
  **/
  @ApiModelProperty(example = "none", required = true, value = "Project funding")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public ProjectCompletePrivate fundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public ProjectCompletePrivate addFundingListItem(FundingInformation fundingListItem) {
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Full Project funding information
   * @return fundingList
  **/
  @ApiModelProperty(required = true, value = "Full Project funding information")
  public List<FundingInformation> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
  }

  public ProjectCompletePrivate description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Project description
   * @return description
  **/
  @ApiModelProperty(example = "description", required = true, value = "Project description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ProjectCompletePrivate collaborators(List<Collaborator> collaborators) {
    this.collaborators = collaborators;
    return this;
  }

  public ProjectCompletePrivate addCollaboratorsItem(Collaborator collaboratorsItem) {
    this.collaborators.add(collaboratorsItem);
    return this;
  }

   /**
   * List of project collaborators
   * @return collaborators
  **/
  @ApiModelProperty(required = true, value = "List of project collaborators")
  public List<Collaborator> getCollaborators() {
    return collaborators;
  }

  public void setCollaborators(List<Collaborator> collaborators) {
    this.collaborators = collaborators;
  }

  public ProjectCompletePrivate quota(Long quota) {
    this.quota = quota;
    return this;
  }

   /**
   * Project quota
   * @return quota
  **/
  @ApiModelProperty(example = "0", required = true, value = "Project quota")
  public Long getQuota() {
    return quota;
  }

  public void setQuota(Long quota) {
    this.quota = quota;
  }

  public ProjectCompletePrivate usedQuota(Long usedQuota) {
    this.usedQuota = usedQuota;
    return this;
  }

   /**
   * Project used quota
   * @return usedQuota
  **/
  @ApiModelProperty(example = "0", required = true, value = "Project used quota")
  public Long getUsedQuota() {
    return usedQuota;
  }

  public void setUsedQuota(Long usedQuota) {
    this.usedQuota = usedQuota;
  }

  public ProjectCompletePrivate createdDate(String createdDate) {
    this.createdDate = createdDate;
    return this;
  }

   /**
   * Date when project was created
   * @return createdDate
  **/
  @ApiModelProperty(example = "2017-05-16T14:52:54Z", required = true, value = "Date when project was created")
  public String getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(String createdDate) {
    this.createdDate = createdDate;
  }

  public ProjectCompletePrivate modifiedDate(String modifiedDate) {
    this.modifiedDate = modifiedDate;
    return this;
  }

   /**
   * Date when project was last modified
   * @return modifiedDate
  **/
  @ApiModelProperty(example = "2017-05-16T14:52:54Z", required = true, value = "Date when project was last modified")
  public String getModifiedDate() {
    return modifiedDate;
  }

  public void setModifiedDate(String modifiedDate) {
    this.modifiedDate = modifiedDate;
  }

  public ProjectCompletePrivate usedQuotaPrivate(Long usedQuotaPrivate) {
    this.usedQuotaPrivate = usedQuotaPrivate;
    return this;
  }

   /**
   * Project private quota used
   * @return usedQuotaPrivate
  **/
  @ApiModelProperty(example = "0", required = true, value = "Project private quota used")
  public Long getUsedQuotaPrivate() {
    return usedQuotaPrivate;
  }

  public void setUsedQuotaPrivate(Long usedQuotaPrivate) {
    this.usedQuotaPrivate = usedQuotaPrivate;
  }

  public ProjectCompletePrivate usedQuotaPublic(Long usedQuotaPublic) {
    this.usedQuotaPublic = usedQuotaPublic;
    return this;
  }

   /**
   * Project public quota used
   * @return usedQuotaPublic
  **/
  @ApiModelProperty(example = "0", required = true, value = "Project public quota used")
  public Long getUsedQuotaPublic() {
    return usedQuotaPublic;
  }

  public void setUsedQuotaPublic(Long usedQuotaPublic) {
    this.usedQuotaPublic = usedQuotaPublic;
  }

  public ProjectCompletePrivate groupId(Long groupId) {
    this.groupId = groupId;
    return this;
  }

   /**
   * Group of project if any
   * @return groupId
  **/
  @ApiModelProperty(example = "0", required = true, value = "Group of project if any")
  public Long getGroupId() {
    return groupId;
  }

  public void setGroupId(Long groupId) {
    this.groupId = groupId;
  }

  public ProjectCompletePrivate accountId(Long accountId) {
    this.accountId = accountId;
    return this;
  }

   /**
   * ID of the account owning the project
   * @return accountId
  **/
  @ApiModelProperty(example = "1000001", required = true, value = "ID of the account owning the project")
  public Long getAccountId() {
    return accountId;
  }

  public void setAccountId(Long accountId) {
    this.accountId = accountId;
  }

  public ProjectCompletePrivate customFields(List<CustomArticleField> customFields) {
    this.customFields = customFields;
    return this;
  }

  public ProjectCompletePrivate addCustomFieldsItem(CustomArticleField customFieldsItem) {
    this.customFields.add(customFieldsItem);
    return this;
  }

   /**
   * Collection custom fields
   * @return customFields
  **/
  @ApiModelProperty(required = true, value = "Collection custom fields")
  public List<CustomArticleField> getCustomFields() {
    return customFields;
  }

  public void setCustomFields(List<CustomArticleField> customFields) {
    this.customFields = customFields;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProjectCompletePrivate projectCompletePrivate = (ProjectCompletePrivate) o;
    return Objects.equals(this.role, projectCompletePrivate.role) &&
        Objects.equals(this.storage, projectCompletePrivate.storage) &&
        Objects.equals(this.url, projectCompletePrivate.url) &&
        Objects.equals(this.id, projectCompletePrivate.id) &&
        Objects.equals(this.title, projectCompletePrivate.title) &&
        Objects.equals(this.funding, projectCompletePrivate.funding) &&
        Objects.equals(this.fundingList, projectCompletePrivate.fundingList) &&
        Objects.equals(this.description, projectCompletePrivate.description) &&
        Objects.equals(this.collaborators, projectCompletePrivate.collaborators) &&
        Objects.equals(this.quota, projectCompletePrivate.quota) &&
        Objects.equals(this.usedQuota, projectCompletePrivate.usedQuota) &&
        Objects.equals(this.createdDate, projectCompletePrivate.createdDate) &&
        Objects.equals(this.modifiedDate, projectCompletePrivate.modifiedDate) &&
        Objects.equals(this.usedQuotaPrivate, projectCompletePrivate.usedQuotaPrivate) &&
        Objects.equals(this.usedQuotaPublic, projectCompletePrivate.usedQuotaPublic) &&
        Objects.equals(this.groupId, projectCompletePrivate.groupId) &&
        Objects.equals(this.accountId, projectCompletePrivate.accountId) &&
        Objects.equals(this.customFields, projectCompletePrivate.customFields) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(role, storage, url, id, title, funding, fundingList, description, collaborators, quota, usedQuota, createdDate, modifiedDate, usedQuotaPrivate, usedQuotaPublic, groupId, accountId, customFields, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProjectCompletePrivate {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    role: ").append(toIndentedString(role)).append("\n");
    sb.append("    storage: ").append(toIndentedString(storage)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    collaborators: ").append(toIndentedString(collaborators)).append("\n");
    sb.append("    quota: ").append(toIndentedString(quota)).append("\n");
    sb.append("    usedQuota: ").append(toIndentedString(usedQuota)).append("\n");
    sb.append("    createdDate: ").append(toIndentedString(createdDate)).append("\n");
    sb.append("    modifiedDate: ").append(toIndentedString(modifiedDate)).append("\n");
    sb.append("    usedQuotaPrivate: ").append(toIndentedString(usedQuotaPrivate)).append("\n");
    sb.append("    usedQuotaPublic: ").append(toIndentedString(usedQuotaPublic)).append("\n");
    sb.append("    groupId: ").append(toIndentedString(groupId)).append("\n");
    sb.append("    accountId: ").append(toIndentedString(accountId)).append("\n");
    sb.append("    customFields: ").append(toIndentedString(customFields)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

