/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.CommonSearch;
import java.io.IOException;

/**
 * ProjectsSearch
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-29T12:13:04.813Z")
public class ProjectsSearch extends CommonSearch {
  @SerializedName("search_for")
  private String searchFor = null;

  @SerializedName("page")
  private Long page = null;

  @SerializedName("page_size")
  private Long pageSize = 10l;

  @SerializedName("limit")
  private Long limit = null;

  @SerializedName("offset")
  private Long offset = null;

  @SerializedName("institution")
  private Integer institution = null;

  @SerializedName("published_since")
  private String publishedSince = null;

  @SerializedName("modified_since")
  private String modifiedSince = null;

  @SerializedName("group")
  private Integer group = null;

  /**
   * The field by which to order.
   */
  @JsonAdapter(OrderEnum.Adapter.class)
  public enum OrderEnum {
    PUBLISHED_DATE("published_date"),
    
    MODIFIED_DATE("modified_date"),
    
    VIEWS("views");

    private String value;

    OrderEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static OrderEnum fromValue(String text) {
      for (OrderEnum b : OrderEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<OrderEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final OrderEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public OrderEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return OrderEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("order")
  private OrderEnum order = OrderEnum.PUBLISHED_DATE;

  public ProjectsSearch searchFor(String searchFor) {
    this.searchFor = searchFor;
    return this;
  }

   /**
   * Search term
   * @return searchFor
  **/
  @ApiModelProperty(example = "figshare", value = "Search term")
  public String getSearchFor() {
    return searchFor;
  }

  public void setSearchFor(String searchFor) {
    this.searchFor = searchFor;
  }

  public ProjectsSearch page(Long page) {
    this.page = page;
    return this;
  }

   /**
   * Page number. Used for pagination with page_size
   * minimum: 1
   * maximum: 5000
   * @return page
  **/
  @ApiModelProperty(example = "1", value = "Page number. Used for pagination with page_size")
  public Long getPage() {
    return page;
  }

  public void setPage(Long page) {
    this.page = page;
  }

  public ProjectsSearch pageSize(Long pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * The number of results included on a page. Used for pagination with page
   * minimum: 1
   * maximum: 1000
   * @return pageSize
  **/
  @ApiModelProperty(example = "10", value = "The number of results included on a page. Used for pagination with page")
  public Long getPageSize() {
    return pageSize;
  }

  public void setPageSize(Long pageSize) {
    this.pageSize = pageSize;
  }

  public ProjectsSearch limit(Long limit) {
    this.limit = limit;
    return this;
  }

   /**
   * Number of results included on a page. Used for pagination with query
   * minimum: 1
   * maximum: 1000
   * @return limit
  **/
  @ApiModelProperty(example = "10", value = "Number of results included on a page. Used for pagination with query")
  public Long getLimit() {
    return limit;
  }

  public void setLimit(Long limit) {
    this.limit = limit;
  }

  public ProjectsSearch offset(Long offset) {
    this.offset = offset;
    return this;
  }

   /**
   * Where to start the listing(the offset of the first result). Used for pagination with limit
   * minimum: 0
   * maximum: 5000
   * @return offset
  **/
  @ApiModelProperty(example = "0", value = "Where to start the listing(the offset of the first result). Used for pagination with limit")
  public Long getOffset() {
    return offset;
  }

  public void setOffset(Long offset) {
    this.offset = offset;
  }

  public ProjectsSearch institution(Integer institution) {
    this.institution = institution;
    return this;
  }

   /**
   * only return collections from this institution
   * @return institution
  **/
  @ApiModelProperty(example = "2000013", value = "only return collections from this institution")
  public Integer getInstitution() {
    return institution;
  }

  public void setInstitution(Integer institution) {
    this.institution = institution;
  }

  public ProjectsSearch publishedSince(String publishedSince) {
    this.publishedSince = publishedSince;
    return this;
  }

   /**
   * Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @return publishedSince
  **/
  @ApiModelProperty(example = "2017-12-22", value = "Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD")
  public String getPublishedSince() {
    return publishedSince;
  }

  public void setPublishedSince(String publishedSince) {
    this.publishedSince = publishedSince;
  }

  public ProjectsSearch modifiedSince(String modifiedSince) {
    this.modifiedSince = modifiedSince;
    return this;
  }

   /**
   * Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @return modifiedSince
  **/
  @ApiModelProperty(example = "2017-12-22", value = "Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD")
  public String getModifiedSince() {
    return modifiedSince;
  }

  public void setModifiedSince(String modifiedSince) {
    this.modifiedSince = modifiedSince;
  }

  public ProjectsSearch group(Integer group) {
    this.group = group;
    return this;
  }

   /**
   * only return collections from this group
   * @return group
  **/
  @ApiModelProperty(example = "2000013", value = "only return collections from this group")
  public Integer getGroup() {
    return group;
  }

  public void setGroup(Integer group) {
    this.group = group;
  }

  public ProjectsSearch order(OrderEnum order) {
    this.order = order;
    return this;
  }

   /**
   * The field by which to order.
   * @return order
  **/
  @ApiModelProperty(example = "published_date", value = "The field by which to order.")
  public OrderEnum getOrder() {
    return order;
  }

  public void setOrder(OrderEnum order) {
    this.order = order;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProjectsSearch projectsSearch = (ProjectsSearch) o;
    return Objects.equals(this.searchFor, projectsSearch.searchFor) &&
        Objects.equals(this.page, projectsSearch.page) &&
        Objects.equals(this.pageSize, projectsSearch.pageSize) &&
        Objects.equals(this.limit, projectsSearch.limit) &&
        Objects.equals(this.offset, projectsSearch.offset) &&
        Objects.equals(this.institution, projectsSearch.institution) &&
        Objects.equals(this.publishedSince, projectsSearch.publishedSince) &&
        Objects.equals(this.modifiedSince, projectsSearch.modifiedSince) &&
        Objects.equals(this.group, projectsSearch.group) &&
        Objects.equals(this.order, projectsSearch.order) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(searchFor, page, pageSize, limit, offset, institution, publishedSince, modifiedSince, group, order, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProjectsSearch {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    searchFor: ").append(toIndentedString(searchFor)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    offset: ").append(toIndentedString(offset)).append("\n");
    sb.append("    institution: ").append(toIndentedString(institution)).append("\n");
    sb.append("    publishedSince: ").append(toIndentedString(publishedSince)).append("\n");
    sb.append("    modifiedSince: ").append(toIndentedString(modifiedSince)).append("\n");
    sb.append("    group: ").append(toIndentedString(group)).append("\n");
    sb.append("    order: ").append(toIndentedString(order)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

